Bug 1986395 (CVE-2021-32791)

Summary: CVE-2021-32791 mod_auth_openidc: hardcoded static IV and AAD with a reused key in AES GCM encryption
Product: [Other] Security Response Reporter: Guilherme de Almeida Suckevicz <gsuckevi>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aboscatt, jhrozek, puiterwijk, spoore, thalman
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: mod_auth_openidc 2.4.9 Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in mod_auth_openidc. The AES GCM encryption uses a static IV and AAD which could lead to other cryptographic attacks. The highest threat from this liability is to data confidentiality.
Story Points: ---
Clone Of: Environment:
Last Closed: 2022-05-11 02:45:34 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1986396, 1987216, 1987217    
Bug Blocks: 1986104    

Description Guilherme de Almeida Suckevicz 2021-07-27 12:51:45 UTC
mod_auth_openidc is an authentication/authorization module for the Apache 2.x HTTP server that functions as an OpenID Connect Relying Party, authenticating users against an OpenID Connect Provider. In mod_auth_openidc before version 2.4.9, the AES GCM encryption in mod_auth_openidc uses a static IV and AAD. It is important to fix because this creates a static nonce and since aes-gcm is a stream cipher, this can lead to known cryptographic issues, since the same key is being reused. From 2.4.9 onwards this has been patched to use dynamic values through usage of cjose AES encryption routines.

References:
https://github.com/zmartzone/mod_auth_openidc/security/advisories/GHSA-px3c-6x7j-3r9r
https://github.com/zmartzone/mod_auth_openidc/releases/tag/v2.4.9

Upstream patch:
https://github.com/zmartzone/mod_auth_openidc/commit/375407c16c61a70b56fdbe13b0d2c8f11398e92c

Comment 1 Guilherme de Almeida Suckevicz 2021-07-27 12:52:12 UTC
Created mod_auth_openidc tracking bugs for this issue:

Affects: fedora-all [bug 1986396]

Comment 3 Riccardo Schirone 2021-08-06 13:01:37 UTC
Attack Complexity set to High (AC:H) because hacving a static IV does not immediately leads to a loss of confidentiality. An attacker needs to intercept some encrypted messages and then perform additional work to recover the original messages.

Comment 4 errata-xmlrpc 2022-05-10 13:39:56 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2022:1823 https://access.redhat.com/errata/RHSA-2022:1823

Comment 5 Product Security DevOps Team 2022-05-11 02:45:33 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2021-32791